#include "BitbloqUS.h"
#include "math.h"

//****** US ******//
US::US(){
}

US::US(int data, unsigned long timeOut){
  US::init(data, timeOut);
}

void US::init(int data, unsigned long timeOut)
{
  _data = data;
  _timeOut = timeOut;
  pinMode( _data , INPUT );
}

long US::TP_init()
{   //---------------write code here--------------
    pinMode(_data,INPUT); // this is required for those cases in which echo and trigger pin are the same
    AnalogRead(_data);
    long analogValue = AnalogRead(_data);
    delay(29);
    return analogValue;
}

float US::read(){
  long analogValue = US::TP_init();
  long temperature;
  temperature = ((1/295.15) + ((1/3435) * log(analogValue/495))) - 273;

  return temperature;
}

void US::setTimeOut(unsigned long timeOut){
  _timeOut = timeOut;
}

BitbloqUltrasound::BitbloqUltrasound():
	_data(-1),
	_timeOut(-1)
{
	
}
BitbloqUltrasound::BitbloqUltrasound(int data, unsigned long timeOut):
	_data(data),
	_timeOut(timeOut)
{

}

void BitbloqUltrasound::setup(int data, unsigned long timeOut){
	_data = data;
	_timeOut = timeOut;
	setup();
}

void BitbloqUltrasound::setup()
{
  pinMode( _data , INPUT );
}

long BitbloqUltrasound::TP_init()
{
    pinMode(_data,INPUT); // this is required for those cases in which echo and trigger pin are the same
    AnalogRead(_data);
    long analogValue = AnalogRead(_data);
    delay(29);
    return analogValue;
}

float BitbloqUltrasound::read(){
  long analogValue = BitbloqUltrasound::TP_init();
  long temperature;
  temperature = ((1/295.15) + ((1/3435) * log(analogValue/495))) - 273;

  return temperature;
}

void BitbloqUltrasound::setTimeOut(unsigned long timeOut){
  _timeOut = timeOut;
}
